-module(nif_demo).
-author("Viktória Fördős").
-email("f-viktoria@elte.hu").

-on_load(load_nif/0).
-export([diff_of_two_squares/2]).
% NIF func.s
-export([add/2, mul/2]).

load_nif()->
    case erlang:load_nif("./priv/nif_demo", 0) of
        ok -> ok;
        _  -> unload
    end.

diff_of_two_squares(A,B) when is_integer(A), is_integer(B) ->
    mul(add(A, B),
        add(A, mul(-1, B)));
diff_of_two_squares(A,B) ->
    A*A - B*B.

mul(_,_) ->
    exit(nif_is_not_loaded).

add(_,_) ->
    exit(nif_is_not_loaded).

